-- debugwin.lua
-- Written by Habna


local player = Turbine.Gameplay.LocalPlayer.GetInstance();
local backpack = player:GetBackpack();
local size = backpack:GetSize();

function frmDebug()
	self = Turbine.UI.Lotro.Window();
	--self = Turbine.UI.Lotro.GoldWindow();
	
	self:SetSize( 775, 445 );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = self:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight / 2 );
    self:SetPosition( left, top );
	self:SetText( "Debug window" );
	self:SetVisible( true );
	--self:SetZOrder( 2 );
	self:Activate();

	--Left side
	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( self );
	lblBackPack:SetText( "Items currently in bag from slot 1 to " .. backpackSize .. "\n Name (Category)(Quality)(Type)" );
	lblBackPack:SetPosition( 15, 35);
	lblBackPack:SetSize( 350 , 35 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblBackPack:SetForeColor( green );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( self );
	ListBoxBorder:SetPosition( lblBackPack:GetLeft() - 2, lblBackPack:GetHeight() + 40 );
	ListBoxBorder:SetSize( 354, 354 );
	ListBoxBorder:SetBackColor( grey );
	ListBoxBorder:SetVisible( true );

	ListBox = Turbine.UI.ListBox();
	ListBox:SetParent( self );
	ListBox:SetPosition( ListBoxBorder:GetLeft() + 2, ListBoxBorder:GetTop() + 2 );
	ListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	ListBox:SetMaxItemsPerLine( 3 );
	ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	ListBox:SetBackColor( black );

	ScrollBar = Turbine.UI.Lotro.ScrollBar();
	ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	ScrollBar:SetParent( self );
	ScrollBar:SetPosition( ListBoxBorder:GetWidth() + 15, ListBoxBorder:GetTop() );
	ScrollBar:SetHeight( ListBoxBorder:GetHeight() );
	ScrollBar:SetWidth( 10 );
	ListBox:SetVerticalScrollBar( ScrollBar );

	RefreshBackPack();


	--Right side
	lblVirtPack = Turbine.UI.Label();
	lblVirtPack:SetParent( self );
	lblVirtPack:SetText( "Items currently in VIRTUAL bag from slot 1 to " .. backpackSize .. " sorted by is weight\n Name (Quantity)(At Slot bag)(Weight)" );
	lblVirtPack:SetPosition( 400, 35);
	lblVirtPack:SetSize( 350 , 35 );
	lblVirtPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblVirtPack:SetForeColor( green );

	rListBoxBorder = Turbine.UI.Control();
	rListBoxBorder:SetParent( self );
	rListBoxBorder:SetPosition( lblVirtPack:GetLeft() - 2, lblVirtPack:GetHeight() + 40 );
	rListBoxBorder:SetSize( 354, 354 );
	rListBoxBorder:SetBackColor( grey );
	rListBoxBorder:SetVisible( true );

	rListBox = Turbine.UI.ListBox();
	rListBox:SetParent( self );
	rListBox:SetPosition( rListBoxBorder:GetLeft() + 2, rListBoxBorder:GetTop() + 2 );
	rListBox:SetSize( rListBoxBorder:GetWidth() - 4, rListBoxBorder:GetHeight() - 4 );
	rListBox:SetMaxItemsPerLine( 3 );
	rListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	rListBox:SetBackColor( black );

	rScrollBar = Turbine.UI.Lotro.ScrollBar();
	rScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	rScrollBar:SetParent( self );
	rScrollBar:SetPosition( self:GetWidth() - 21, rListBoxBorder:GetTop() );
	rScrollBar:SetHeight( rListBoxBorder:GetHeight() );
	rScrollBar:SetWidth( 10 );
	rListBox:SetVerticalScrollBar( rScrollBar );

	RefreshVirtualBackPack();
end

function RefreshBackPack()	
	BPItem = {};
	itemsCtl = {};
	itemsLbl = {};
	lblrow = {};
	ListBox:ClearItems();
	
	for i = 1, size do
		-- Slot number
		lblrow[i] = Turbine.UI.Label();
		lblrow[i]:SetSize( 20, 35 );
		lblrow[i]:SetPosition( 5, 15 );
		lblrow[i]:SetText( i );
		lblrow[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		lblrow[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		lblrow[i]:SetForeColor( white );
		ListBox:AddItem( lblrow[i] );

		-- Item background
		itemsCtl[i] = Turbine.UI.Control();
		itemsCtl[i]:SetSize( 35, 35 );
		itemsCtl[i]:SetBackground( "HabnaPlugins/HugeBag/Resources/slotBackground.tga" );
		itemsCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );		

		-- Item
		item = backpack:GetItem( i );
		if item ~= nil then
			BPItem[i] = Turbine.UI.Lotro.ItemControl( backpack:GetItem( i ) );
			BPItem[i]:SetParent( itemsCtl[i] );
			ListBox:AddItem( itemsCtl[i] );
		else
			ListBox:AddItem( itemsCtl[i] );
		end
		
		-- Item name, Cat, type, quality
		itemsLbl[i] = Turbine.UI.Label();
		itemsLbl[i]:SetSize( ListBox:GetWidth() - 35, 35 );
		itemsLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		itemsLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		itemsLbl[i]:SetForeColor( white );

		if item ~= nil then
			itemsLbl[i].Name = item:GetName();
			itemsLbl[i].Cat = item:GetCategory();
			itemsLbl[i].Type = ItemCategory[itemsLbl[i].Cat];
			--write(tostring(itemsLbl[i].Type));
			if itemsLbl[i].Type == nil then itemsLbl[i].Type = "SpecialTrophy"; end
			itemsLbl[i].Quality = item:GetQuality();
			itemsLbl[i]:SetText( itemsLbl[i].Name .. "\n (" .. itemsLbl[i].Cat .. ")(" .. itemsLbl[i].Quality .. ")(" .. itemsLbl[i].Type .. ")" );
		else
			itemsLbl[i].Name = "zEmpty";
			itemsLbl[i]:SetText( itemsLbl[i].Name );
		end
		ListBox:AddItem( itemsLbl[i] );
	end
end

function RefreshVirtualBackPack()
	local VirtPack = {};

	for i = 1, size do
		VirtPack[i] = {};
		VirtPack[i].id = i;

		local item = backpack:GetItem( i );

		VirtPack[i].Item = Turbine.UI.Lotro.ItemControl( item );

		if item ~= nil then
			VirtPack[i].Name = item:GetName();
			
			local Quality = item:GetQuality();
			if Quality == nil then Quality = 0; end

			local Quantity = item:GetQuantity();
			if Quantity == nil then Quantity = 1; end
			VirtPack[i].Quantity = Quantity;
			
			local CatWeight = value[itemsLbl[i].Type] --[ItemCategory[item:GetCategory()]];
			
			VirtPack[i].Weight = CatWeight * 10 + Quality;
		else
			VirtPack[i].Name = "zEmpty";
			VirtPack[i].Item = nil;
			VirtPack[i].Quantity = 0;
			VirtPack[i].Weight = 99999;
		end
	end

	--Sort VirtPack. If the weight of two items is the same compare the Names, after removing some characters.
	--This way 2 Morale Potions will get sorted with "Morale Potions"
	table.sort(VirtPack, function (a,b)	
		if a.Weight == b.Weight then
			if a.Name == b.Name then 
				return (a.Quantity < b.Quantity)
			else  
				return strip(a.Name) < strip(b.Name)
			end
		else  
			return (a.Weight < b.Weight) 
		end
		end)
	
	--[[--debug print to chat box
	for x = 1, backpackSize do
		write("-> " .. VirtPack[x].Name .. "\n In slot: " .. VirtPack[x].id .. " (C: " .. VirtPack[x].Cat .. ")(T: " .. VirtPack[x].Type .. ")(Q: " .. VirtPack[x].Quality .. ")(W: " .. VirtPack[x].Weight .. ")" );
	end
	]]

	itemsCtl = {};
	itemsLbl = {};
	lblrow = {};
	rListBox:ClearItems();

	for i = 1, size do
		-- Slot number
		lblrow[i] = Turbine.UI.Label();
		lblrow[i]:SetSize( 20, 35 );
		lblrow[i]:SetPosition( 5, 15 );
		lblrow[i]:SetText( i );
		lblrow[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		lblrow[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		lblrow[i]:SetForeColor( white );
		rListBox:AddItem( lblrow[i] );
		
		-- Item background
		itemsCtl[i] = Turbine.UI.Control();
		itemsCtl[i]:SetSize( 35, 35 );
		itemsCtl[i]:SetBackground( "HabnaPlugins/HugeBag/Resources/slotBackground.tga" );
		itemsCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
		-- Item
		item = VirtPack[i].Item;
		if item ~= nil then
			item:SetParent( itemsCtl[i] );
			rListBox:AddItem( itemsCtl[i] );
		else
			rListBox:AddItem( itemsCtl[i] );
		end

		-- Item name, slot & weight
		itemsLbl[i] = Turbine.UI.Label();
		itemsLbl[i]:SetSize( ListBox:GetWidth() - 35, 35 );
		itemsLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		itemsLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		itemsLbl[i]:SetForeColor( white );
		
		itemsLbl[i]:SetText( VirtPack[i].Name .. "\n (" .. VirtPack[i].Quantity .. ")(At slot: " .. VirtPack[i].id ..")(" .. VirtPack[i].Weight .. ")" );
		rListBox:AddItem( itemsLbl[i] );
	end
end

function strip(str)
	--Strip numbers first 7 characters to make the sort more logical
	local left=string.sub(str, 1, 7)
	local right=string.sub(str, 8)
	left=string.gsub(left,"[^%a]","")
	str= left .. right
	
	--Strip all spaces now!
	str=string.gsub(str,"[%s]","")
	return str
end